package org.nl.acs.plc.service;

import com.alibaba.fastjson.JSONArray;
import org.nl.acs.common.base.PageInfo;
import org.nl.acs.common.base.CommonService;
import org.nl.acs.opc.domain.OpcPlc;
import org.nl.acs.opc.service.dto.OpcPlcDto;
import org.nl.acs.opc.service.dto.OpcPlcQueryParam;
import org.springframework.data.domain.Pageable;
import java.util.List;
import java.util.Set;

/**
* @author jiaolm
* @date 2023-05-09
*/
public interface OpcPlcService extends CommonService<OpcPlc>  {

    static final String CACHE_KEY = "opcPlc";

    /**
    * 查询数据分页
    * @param query 条件
    * @param pageable 分页参数
    * @return PageInfo<OpcPlcDto>
    */
    PageInfo<OpcPlcDto> queryAll(OpcPlcQueryParam query, Pageable pageable);

    /**
    * 查询所有数据不分页
    * @param query 条件参数
    * @return List<OpcPlcDto>
    */
    List<OpcPlcDto> queryAll(OpcPlcQueryParam query);

    OpcPlc getById(String id);
    OpcPlcDto findById(String id);

    /**
     * 插入一条新数据。
     */
    int insert(OpcPlcDto resources);
    int updateById(OpcPlcDto resources);
    int removeById(String id);
    int removeByIds(Set<String> ids);

    /**
    * 导出数据
    * @param all 待导出的数据
    * @param response /
    * @throws IOException /
    */
    // void download(List<OpcPlcDto> all, HttpServletResponse response) throws IOException;

    /**
     * 前端PLC下拉选列表
     *
     * @return
     */
    List<OpcPlc> selectList();

    /**
     * 根据OPC标识得到前端PLC下拉选列表
     *
     * @return
     */
    List<OpcPlc>  selectListByOpcID(String opc_uuid);
}
